// Type definitions for Confefe 1.0
// Project: https://github.com/thorsedeke/confefe
// Definitions by: Thor Sedeke <thor.sedeke@gmail.com>
// Definitions: 
// TypeScript Version: 2.8

/* =================== USAGE ===================

    import * as Confefe from "confefe"
    const config = new Confefe()

    const myValue = config.get("path.to.myValue");

 =============================================== */

declare class Confefe {
  private readonly options: { [key:string]: any };

  constructor(options?: { [key:string]: any });
  set(key:string, value:any): Confefe;
  has(key:string): boolean;
  get(key: string, defaultValue?: any): any;
  clean(): Confefe;
  store(): object;
  load(path?: string): Confefe;
  getConfigSources(): string[];
  getEnvironment(): string;
  setEnvironment(env:string): Confefe;
  getConfigDirs(): string[];
  setConfigDirs(dirs: string|string[]): Confefe;
  setHostname(hostname?: string): Confefe;
  getHostname(): string;
  importFile(file: string, dir: string, namespace: string): Confefe;
}

declare namespace Confefe {}

export = Confefe;
